MishaTools_LoadScripts.RequireOnce(
['ContractManager/Controller.js',
'MishaTools/Canvas.js'],
function() {
	ContractManager_Controller_Application = Class.create(ContractManager_Controller,{
		initialize: function($super,config,container,canvas,service,logo) {
			$super(container);
			
			this.canvas = new MishaTools_Canvas(canvas);
			this.logo = logo;
			this.config = config;
			this.service = service;
			this.drawingstack = [];
		},
		
		activate: function($super) {
			$super();
			
			this._draw();
			this.canvas.play();
		},
		
		deactivate: function($super) {
			$super();
			this.canvas.stop();
		},
		
		_draw:function() {
			var header = new MishaTools_Canvas_Rectangle('headerbackground',[726,100.5],this.config.header_color,null,this.canvas.stage,[74,1]);
			var logo = new MishaTools_Canvas_Image('logo',this.logo,this.canvas.stage,[0,1]);
			var border = new MishaTools_Canvas_Object('border',[this.canvas.canvas.width,this.canvas.canvas.height],null,this.config.border_color,this.canvas.stage,[0,0]);	
		}
		
		_drawCompanyName: function() {
			this.service.getCompanyInfo(this._bindAsDrawingCallback(function(response) {
				//TODO: figure out whether/how to handle empty/long values
				this.context.save();
				this.context.font = this.config.header_font;
				this.context.fillText(response.address,80,20);
				this.context.restore();
			 }));
		},
		
		_bindAsDrawingCallback: function(callback) {
			
			var boundCallback = function () {
				if(this.drawingstack.indexOf(boundCallback) != -1) {
					this.drawingstack.splice(this.drawingstack.indexOf(boundCallback),1);
					return callback.apply(this,arguments);
				}
			}.bind(this);
			
			this.drawingstack.push(boundCallback);
			return boundCallback;
		},
		
		_clearDrawingCallbacks: function() {
			this.drawingstack = [];
		}
	});
});