MishaTools_LoadScripts.RequireOnce(
[['http://www.google.com/recaptcha/api/js/recaptcha_ajax.js','Recaptcha'],
'ContractManager/Controller.js'],
function() {
	ContractManager_Controller_UserLogin = Class.create(ContractManager_Controller,{
		
		initialize: function($super,config,loginservice,container,usernamefield,passwordfield,captchafield,messagefield,submitbutton) {
			$super(container);
			
			this.config = config;
			this.loginservice = loginservice;
			this.usernamefield = usernamefield;
			this.passwordfield = passwordfield;
			this.captchafield = captchafield;
			this.messagefield = messagefield;
			this.submitbutton = submitbutton;
		},
		
		activate: function($super,callback) {
			$super();
			
			this.callback = callback;
			this.submitbutton.observe('click',this._authenticate.bindAsEventListener(this));
			this.usernamefield.observe('keypress',(function(e) { if(e.keyCode == Event.KEY_RETURN) this._authenticate(); }).bindAsEventListener(this));
			this.passwordfield.observe('keypress',(function(e) { if(e.keyCode == Event.KEY_RETURN) this._authenticate(); }).bindAsEventListener(this));
		},
		
		_authenticate: function() {
			var EmailValidator = new RegExp(this.config.email_validation);
			
			if(this.usernamefield.present() && this.passwordfield.present() && EmailValidator.test(this.usernamefield.getValue())) {
				this.submitbutton.hide();
				this.loginservice.isCaptchaRequired(this.usernamefield.getValue(),this._isCaptchaRequiredResponse.bind(this));
			}
		},
		
		_isCaptchaRequiredResponse:function(response) {
			if(response.response) {
				Recaptcha.create(this.config.recaptcha_public_key,this.captchafield,{theme:'white',callback:this._captchaLoaded.bind(this,response.message)});
			} else {
				this.loginservice.authenticate(this.usernamefield.getValue(),this.passwordfield.getValue(),null,this._authenticateResponse.bind(this));
			}
		},
		
		_captchaLoaded: function(message) {
			this.messagefield.update(message);
			
			$('recaptcha_response_field').observe('keypress',function(e) { if(e.keyCode == Event.KEY_RETURN) if(Recaptcha.get_response()) { this._captchaSubmit(); }}.bindAsEventListener(this));
			Recaptcha.focus_response_field();
			
			this.container.observe('click',this._resetOnClickOutsideCaptcha.bindAsEventListener(this));
		},
		
		_captchaSubmit: function() {
			var challenge = Recaptcha.get_challenge();
			var response = Recaptcha.get_response();
			
			Recaptcha.destroy();
			this.messagefield.update('');
			this.loginservice.authenticate(this.usernamefield.getValue(),this.passwordfield.getValue(),{challenge:challenge, response:response},this._authenticateResponse.bind(this));
		},
		
		_reset: function() {
			this.container.stopObserving('click');
			this.messagefield.update('');
			this.submitbutton.show();
		},
		
		_authenticateResponse: function(response) {
			if(response.response) {
				this._reset();
				this.deactivate();
				this.callback();
			} else {
				this.messagefield.update(response.message);
				this.container.observe('click',this._reset.bindAsEventListener(this));
			}
		},
		
		_resetOnClickOutsideCaptcha: function(e) {
			if(!e.target.descendantOf(this.captchafield)) {
				Recaptcha.destroy();
				this._reset();
			}
		}
	});
});