MishaTools_LoadScripts.RequireOnce(
['ContractManager/Config.js',
'MishaTools/Canvas/Rect.js',
'MishaTools/Canvas/Rect/Image.js',
'MishaTools/Canvas/Rect/Textbox.js',
'MishaTools/Canvas/Rect/Button.js'],
function() {
	ContractManager_Login = Class.create(MishaTools_Canvas_Rect,{
		initialize: function($super,id) {
			$super(id);
			
			LoadImages(
			['images/logo.png',
			'images/icons/person.png',
			'images/icons/lock.png',
			'images/icons/checkbutton.png',
			'images/icons/checkbutton_green.png'],
			function(images) {
				var logoimage = images[0], usernameimage = images[1], passwordimage = images[2], loginimageup = images[3], loginimageover = images[4];
				
				var logo = MishaTools_Canvas_Rect_Image.FromDOMImage('logo',logoimage);
				logo.center($C(0,-50));
				this.addChild(logo);
	
				var usernameicon = MishaTools_Canvas_Rect_Image.FromDOMImage('usernameicon',usernameimage);
				usernameicon.center($C(-90,71));
				this.addChild(usernameicon);
				
				var username = new MishaTools_Canvas_Rect_Textbox('username');
				username.setFamilyOptions({
					size:$C(155,24),
					taborder:1,
					background:{
						stroke:'rgba(0,0,0,1)',
						fill:'rgba(245,207,174,.5)'
					},
					text:{
						fontname:'AvenirLight',
						fontsize:14,
						keyboard:'email'
					}
				});
				username.center($C(0,71));
				this.addChild(username);
				
				var passwordicon = MishaTools_Canvas_Rect_Image.FromDOMImage('passwordicon',passwordimage);
				passwordicon.center($C(-89,102));
				this.addChild(passwordicon);
				
				var password = new MishaTools_Canvas_Rect_Textbox('password');
				password.setFamilyOptions({
					size:$C(155,24),
					taborder:2,
					background:{
						stroke:'rgba(0,0,0,1)',
						fill:'rgba(245,207,174,.5)'
					},
					text:{
						fontname:'AvenirLight',
						fontsize:14,
						obscure:true
					}
				});
				password.center($C(0,101));
				this.addChild(password);
				
				var loginbutton = MishaTools_Canvas_Rect_Button.Create3ImageButton(	'loginbutton',
																					MishaTools_Canvas_Rect_Image.FromDOMImage('loginup',loginimageup),
																					MishaTools_Canvas_Rect_Image.FromDOMImage('loginover',loginimageover));
				
				loginbutton.observe('mousedown',function(e) { this.login(); }.bind(this));
				loginbutton.center($C(66,135));
				this.addChild(loginbutton);
				
				this.observe('keydown',function(e) {
					if(e.data.event.keyCode == Event.KEY_RETURN) this.login();
				}.bind(this));
				
			}.bind(this));
		},
		
		validate:function() {
			var emailvalidator = new RegExp(ContractManager_Config.Login.email_validation);
			
			var username = this.getChild('username','text').getOptions('text');
			var validusername = emailvalidator.test(username);
			var password = this.getChild('password','text').getOptions('text');
			
			if(!validusername) this.getChild('username','background').setOptions({stroke:'rgba(199,56,6,1)'});
			else this.getChild('username','background').setOptions({stroke:'rgba(0,0,0,1)'});
				
			if(!password) this.getChild('password','background').setOptions({stroke:'rgba(199,56,6,1)'});
			else this.getChild('password','background').setOptions({stroke:'rgba(0,0,0,1)'});
				
			return !(!validusername || !password);
		},
		
		login:function() {
			if(!this.validate()) return;
			
			
		}
	});
});