MishaTools_LoadScripts.RequireOnce(
['MishaTools/Canvas/Coordinate.js',
'MishaTools/Canvas/Coordinate/Rect.js'],
function() {

	$CP = function() {
		if(arguments.length == 1) {
			return new MishaTools_Canvas_Coordinate_Polar({q:arguments[0].q,r:arguments[0].r});
		} else {
			return new MishaTools_Canvas_Coordinate_Polar({q:arguments[0],r:arguments[1]});
		}
	};
	
	MishaTools_Canvas_Coordinate_Polar = Class.create(MishaTools_Canvas_Coordinate,{
	
		initialize:function(coord) {
			this.q = coord.q;
			this.r = coord.r;
		},
		
		add:function(coord) {
			return $CP(this.q + coord.r,this.q + coord.r);
		},
		
		subtract:function(coord) {
			return $CP(this.q - coord.q,this.r - coord.r);
		},
		
		rotate:function(q) {
			return $CP(this.q + q, this.r);
		},
		
		multiply:function(coord) {
			return $CP(this.q * coord.q,this.r * coord.r);
		},
		
		divide:function(coord) {
			return $CP(this.q / coord.q,this.r / coord.r);
		},
		
		toRect:function() {
			return $C(this.r * Math.cos(this.q),this.r * Math.sin(this.q));
		},
		
		inDirection:function(q) {
			var q1 = this.q;
			var q2 = q;
			var absq1 = Math.abs(this.q);
			var absq2 = Math.abs(q);
			
			var dq = Math.abs(absq2-absq1);
			var r2 = this.r * Math.cos(dq);
			
			if(q2 > q1 + Math.PI/2 && q2 < q1 + 3 * Math.PI/2) r2 = r2 * -1;
			
			return r2;
		}
	});
});