MishaTools_LoadScripts.RequireOnce(
['MishaTools/Canvas/Coordinate.js',
'MishaTools/Canvas/Coordinate/Polar.js'],
function() {

	$C = function() {
		if(arguments.length == 1) {
			if(Object.isNumber(arguments[0])) {
				return new MishaTools_Canvas_Coordinate_Rect({x:arguments[0],y:arguments[0]});
			} else {
				return new MishaTools_Canvas_Coordinate_Rect({x:arguments[0].x,y:arguments[0].y});
			}
		} else {
			return new MishaTools_Canvas_Coordinate_Rect({x:arguments[0],y:arguments[1]});
		}
	};
	
	MishaTools_Canvas_Coordinate_Rect = Class.create(MishaTools_Canvas_Coordinate,{
	
		initialize:function(coord) {
			this.x = coord.x;
			this.y = coord.y;
		},
		
		add:function(coord) {
			if(Object.isNumber(coord)) {
				coord = $C(coord,coord);
			}
			
			return $C(this.x + coord.x,this.y + coord.y);
		},
		
		subtract:function(coord) {
			if(Object.isNumber(coord)) {
				coord = $C(coord,coord);
			}
			
			return $C(this.x - coord.x,this.y - coord.y);
		},
		
		multiply:function(coord) {
			if(Object.isNumber(coord)) {
				coord = $C(coord,coord);
			}
			
			return $C(this.x * coord.x,this.y * coord.y);
		},
		
		divide:function(coord) {
			if(Object.isNumber(coord)) {
				coord = $C(coord,coord);
			}
			
			return $C(this.x / coord.x,this.y / coord.y);
		},
		
		toPolar:function() {
			return $CP(Math.atan2(this.y,this.x),Math.sqrt(Math.pow(this.x,2) + Math.pow(this.y,2)));
		},
		
		equals:function(coord) {
			if(Object.isNumber(coord)) {
				coord = $C(coord,coord);
			}
			
			return coord.x == this.x && coord.y == this.y;
		},
		
		lessThan:function(coord,equalto) {
			if(Object.isNumber(coord)) {
					coord = $C(coord,coord);
			}
			
			return equalto ? coord.x >= this.x && coord.y >= this.y : coord.x > this.x && coord.y > this.y;
		},
		
		greaterThan:function(coord,equalto) {
			if(Object.isNumber(coord)) {
					coord = $C(coord,coord);
			}
			
			return equalto ? coord.x <= this.x && coord.y <= this.y : coord.x < this.x && coord.y < this.y;
		},
		
		round:function() {
			return $C(Math.round(this.x),Math.round(this.y));
		},
		
		abs:function() {
			return $C(Math.abs(this.x),Math.abs(this.y));
		}
	});
});