MishaTools_LoadScripts.RequireOnce(
['MishaTools/Canvas/Rect.js'],
function() {
	MishaTools_Canvas_Rect_Button = Class.create(MishaTools_Canvas_Rect,{
		
		initialize:function($super,id) {
			$super(id);
			
			this.observe('mouseover',function(e) { this.setOptions({state:'over'}); }.bindAsEventListener(this));
			this.observe('mouseout',function(e) { this.setOptions({state:'up'}); }.bindAsEventListener(this));
			this.observe('mousedown',function(e) { this.setOptions({state:'down'}); }.bindAsEventListener(this));
			this.observe('mouseup',function(e) { if(this.getOptions('state') != 'up') this.setOptions({state:'over'}); }.bindAsEventListener(this));
			
			var changecursorlistener = function(e) {
				var state = e.data.newvalue;
				if(state == 'up') {
					if(this.canvas) this.canvas.context.canvas.setStyle({cursor:'auto'});
				} else if(state == 'over') {
					if(this.canvas) this.canvas.context.canvas.setStyle({cursor:'pointer'});
				}
			}.bind(this);
			
			$O(this,'buttoncursor').observe('changed',function(e) {
				var oldusebuttoncursor = e.data.oldvalue;
				var usebuttoncursor = e.data.newvalue;
				
				if(usebuttoncursor) $O(this,'state').observe('changed',changecursorlistener);
				else {
					$O(this,'state').stopObserving('changed',changecursorlistener);
					
					if(oldusebuttoncursor) {
						var state = this.getOptions('state');
						if(state == 'over' || state == 'down') {
							if(this.canvas) this.canvas.context.canvas.setStyle({cursor:'auto'});
						}
					}
				}
			}.bind(this));
			
			this.setOptions({
				buttoncursor:true
			});
		}
	});
	
	Object.extend(MishaTools_Canvas_Rect_Button,{
		Create3ImageButton:function(id,upimage,overimage,downimage) {
			if(!downimage) downimage = overimage;
			
			var stateimages = {up:upimage,over:overimage,down:downimage};
			
			var button = new MishaTools_Canvas_Rect_Button(id);
			button.setOptions({size:upimage.getOptions('size')});
			
			$O(button,'state').observe('changed',function(e) {
				var oldstate = e.data.oldvalue;
				var state = e.data.newvalue;
				
				if(oldstate) this.removeChild(stateimages[oldstate]);
				this.addChild(stateimages[state]);
			}.bind(button));
			
			button.setOptions({state:'up'});
			
			return button;
		}
	});
});