MishaTools_LoadScripts.RequireOnce(
['MishaTools/Canvas/Rect.js',
'MishaTools/Canvas/Rect/Button.js'],
function() {
	MishaTools_Canvas_Rect_Scrollbar = Class.create(MishaTools_Canvas_Rect,{
		
		initialize:function($super,id) {
			
			$super(id);
			
			this.setOptionDefinitions({
				scroll:{value:0}, //between 0 and scrollmax
				scrollmax:{value:100} //positive integer
			});
			
			var scrolltrack = new MishaTools_Canvas_Rect_Button('scrolltrack');
			
			var scrollmarker = new MishaTools_Canvas_Rect_Button('scrollmarker');
			
			scrollmarker.setOptionDefinitions({
				origin:{
						func:function(scroll,scrollmax,scrollbarsize,size) { return $C(Math.round((scrollbarsize.x - size.x) * (scrollmax > 0 ? scroll/scrollmax : 0)),scrollbarsize.y/2 - size.y/2); },
						dependencies:[$O(this,'scroll'),$O(this,'scrollmax'),$O(this,'size'),$O(scrollmarker,'size')],
				},
				size:{
					func:function(scrollbarsize) { return $C(scrollbarsize.y); },
					dependencies:[$O(this,'size')]
				}
			});
			
			this.addChild(scrolltrack);
			this.addChild(scrollmarker);
			
			scrolltrack.observe('mousedown',
				function(e) {
					var size = this.getOptions('size');
					var scrollmax = this.getOptions('scrollmax');
					this.setOptions({scroll:Math.max(Math.min(Math.round(this.globalToLocal(e.data.position).x/size.x * scrollmax),scrollmax),0)});
				}.bindAsEventListener(this));
				
			scrollmarker.observe('mousedrag',
				function(e) {
					var size = this.getOptions('size');
					var scrollmax = this.getOptions('scrollmax');
					this.setOptions({scroll:Math.max(Math.min(Math.round(this.globalToLocal(e.data.position).x/size.x * scrollmax),scrollmax),0)});
				}.bindAsEventListener(this));
				
			this.observe('mousescroll',
				function(e) {
					var scroll = this.getOptions('scroll');
					var scrollmax = this.getOptions('scrollmax');
					this.setOptions({scroll:Math.max(Math.min(Math.round(scroll+e.data.scroll),scrollmax),0)});
					
				}.bindAsEventListener(this));
				
			$O(this,'scrollmax').observe('changed',function(e) {
				if(e.data.newvalue > 0 && e.data.oldvalue == 0) {
					this.addChild(scrollmarker);
				} else if(e.data.newvalue == 0 && e.data.oldvalue > 0) {
					this.removeChild(scrollmarker);
				}
			}.bind(this));
		}
	});
});