MishaTools_LoadScripts.RequireOnce(
['MishaTools/Canvas/Rect.js'],
function() {
	MishaTools_Canvas_Rect_Text = Class.create(MishaTools_Canvas_Rect,{
		
		initialize:function($super,id) {
			$super(id);
			
			this.setOptionDefinitions({
				text:{value:''},
				lineoffset:{value:0},
				xoffset:{value:0,render:true},
				fontsize:{value:12},
				fontname:{value:'Helvetica'},
				textfill:{value:'black', render:true},
				wrapstyle:{value:'literal'},
				obscure:{value:false},
				align:{value:'left', render:true},
				_lines:{
						func:function(text,obscure,size,fontname,fontsize,wrapstyle) {
							if(obscure) text = String.fromCharCode(8226).times(text.length);
							var cache = MishaTools_Canvas_Cache.GetFreeCache(false);
							var ctx = cache.context;
							ctx.font = fontsize + 'px ' + fontname;
							
							var lines = MishaTools_Canvas_Rect_Text.WrapText(text,wrapstyle,size.x,null,ctx);
							cache.release();
							return lines;
						},
						dependencies:[$O(this,'text'),$O(this,'obscure'),$O(this,'size'),$O(this,'fontname'),$O(this,'fontsize'),$O(this,'wrapstyle')],
						equalityfunc:function(oldval,newval) { return ArrayCompare(oldval,newval); }
				},
				_renderlines:{
						func:function(lines,lineoffset,size,fontsize) {
							return lines.slice(lineoffset).inject([],function(agg,line,num) {
								if((num + 1) * fontsize <= size.y) {
									agg.push(line);
								}
								else throw $break;
								return agg;
							});
						},
						dependencies:[$O(this,'_lines'),$O(this,'lineoffset'),$O(this,'size'),$O(this,'fontsize')],
						equalityfunc:function(oldval,newval) { return ArrayCompare(oldval,newval); },
						render:true
				},
				_textareasize:{
					func:function(lines,fontsize,fontname,size) {
						var cache = MishaTools_Canvas_Cache.GetFreeCache(false);
						var ctx = cache.context;
						ctx.font = fontsize + 'px ' + fontname;
						
						var maxlinewidth = 0;
						for(var i=0;i<lines.length;i++) {
							maxlinewidth = Math.max(maxlinewidth,ctx.measureText(lines[i]).width);
						}
						
						cache.release();
						return $C(Math.floor(Math.max(maxlinewidth,size.x)),Math.max(fontsize * lines.length,size.y));
					},
					dependencies:[$O(this,'_lines'),$O(this,'fontsize'),$O(this,'fontname'),$O(this,'size')]
				}
			});
		},
		
		_render:function(ctx) {
			var lines = this.getOptions('_renderlines');
			var textfill = this.getOptions('textfill');
			var fontsize = this.getOptions('fontsize');
			var fontname = this.getOptions('fontname');
			var xoffset = this.getOptions('xoffset');
			var align = this.getOptions('align');
			var size = this.getOptions('size');
			var textareasize = this.getOptions('_textareasize');
			
			if(textfill) {
				ctx.fillStyle = textfill;
				ctx.textBaseline = 'top';
				ctx.font = fontsize + 'px ' + fontname;
				
				lines.each(function(line,num) {
					var xcoord;
					if(align == 'left') xcoord = -xoffset;
					else if(align == 'right') xcoord = -xoffset + Math.max(textareasize.x - Math.floor(ctx.measureText(line).width),0);
					else if(align == 'center') xcoord = -xoffset + Math.max(Math.floor((textareasize.x - ctx.measureText(line).width)/2),0);
					ctx.fillText(line,xcoord,fontsize * num);
				});
			}
		}/*,
		
		linkToScrollbar:function(scrollbar) {
			scrollbar.setOptionDefinitions({
				scroll:{value:this.getOptions('lineoffset')},
				scrollmax:{
					func:function(lines,renderlines) {
						return lines.length-1-renderlines.length+1;
					},
					dependencies:[$O(this,'_lines'),$O(this,'_renderlines')]
				}
			});
			
			$O(scrollbar,'scroll').observe('changed',function(e) {
				this.setOptions({
					lineoffset:e.data.newvalue
				});
			}.bind(this));
			
			$O(this,'lineoffset').observe('changed',function(e) {
				scrollbar.setOptions({
					scroll:e.data.newvalue
				});
			}.bind(this));
		}*/
	});
	
	Object.extend(MishaTools_Canvas_Rect_Text,{
		WrapText:function(text,style,width,maxlines,ctx) {
			if(!style) style = 'width';

			if(!text || (Object.isNumber(maxlines) && maxlines == 0) || (style != 'literal' && width == 0)) return [''];
			
			var hardreturns = text.split('\n');
			if(style == 'literal') return hardreturns;
			
			if(hardreturns.length > 1) {
				return hardreturns.inject([],function(agg,line) {
					var linesleft;
					
					if(Object.isNumber(maxlines)) {
						linesleft = maxlines - agg.length;
						if(linesleft == 0) throw $break;
					} else linesleft = null;
					
					var lines = MishaTools_Canvas_Rect_Text.WrapText(line,style,width,linesleft,ctx);
					if(lines.length == 0) agg.push('');
					else agg = agg.concat(lines);
					return agg;
				});
			} else {
				var textwidth = ctx.measureText(text).width;
				if(textwidth <= width) return [text];
				else {
					var words = text.split(' ');
					var i = 0;
					var iwidth = 0;
					var line;
					
					if(ctx.measureText(words[0].split('-')[0]).width > width || style == 'width') {
						//take the text up to the width
						var i = 0;
						var iwidth = 0;
						while(iwidth <= width) {
							iwidth = ctx.measureText(text.substring(0,++i)).width;
						}
						
						line = text.substring(0,i-1);
					} else {
						
						while(iwidth <= width) {
							iwidth = ctx.measureText(words.slice(0,++i).join(' ')).width;
						}
						
						var lastwordhyphens = words[i-1].split('-');
						if(lastwordhyphens.length > 1) {
							//try removing components of the hyphen to see if it fits
							var j = 0;
							var jwidth = 0;
							var overagewidth = iwidth - width;
							
							for(var j=lastwordhyphens.length-1;j>0;j--) {
								jwidth = ctx.measureText(lastwordhyphens.slice(j,lastwordhyphens.length).join('-')).width;
								if(jwidth >= overagewidth) {
									line = words.slice(0,i).join(' ');
									line = line.substr(0,line.length-lastwordhyphens.slice(j,lastwordhyphens.length).join('-').length);
									break;
								}
							}
							
							if(jwidth < overagewidth) {
								line = words.slice(0,i-1).join(' ');
							}
							
						} else {
							line = words.slice(0,i-1).join(' ');
						}
					}
					
					if(Object.isNumber(maxlines)) {
						maxlines = maxlines - 1;
						if(maxlines == 0) return [line];
					}
					
					var resttext = text.substring(line.length);
					
					if(resttext[0] == ' ' && style == 'layout') {
						resttext = resttext.substring(1);
					}
					
					return [line].concat(MishaTools_Canvas_Rect_Text.WrapText(resttext,style,width,maxlines,ctx));
				}
			}
		}
	});
});