function $T() {
	return new MishaTools_Canvas_Transform(arguments[0],arguments[1],arguments[2],arguments[3],arguments[4],arguments[5],arguments[6]);
}

MishaTools_Canvas_Transform = Class.create({

	initialize:function(m11,m12,m21,m22,dx,dy) {
		this.m11 = m11;
		this.m12 = m12;
		this.m21 = m21;
		this.m22 = m22;
		this.dx = dx;
		this.dy = dy;
	},
	
	multiply:function(trans) {
		return $T(this.m11 * trans.m11 + this.m12 * trans.m21,
				  this.m11 * trans.m12 + this.m12 * trans.m22,
				  this.m21 * trans.m11 + this.m22 * trans.m21,
				  this.m21 * trans.m12 + this.m22 * trans.m22,
				  this.m11 * trans.dx + this.m12 * trans.dy + this.dx,
				  this.m21 * trans.dx + this.m22 * trans.dy + this.dy);
				  
	},
	
	rotate:function(q) {
		return this.multiply($T(Math.cos(q),-Math.sin(q),Math.sin(q),Math.cos(q),0,0));
	},
	
	scale:function(coord) {
		return this.multiply($T(coord.x,0,0,coord.y,0,0));
	},
	
	reflect:function(yaxis) {
		var sign = yaxis ? -1 : 1;
		return this.multiply($T(1 * sign,0,0,-1 * sign,0,0));
	},
	
	translate:function(coord) {
		return this.multiply($T(1,0,0,1,coord.x,coord.y));
	},
	
	shear:function(coord) {
		return this.multiply($T(1,coord.x,coord.y,1,0,0));
	},
	
	rotateAroundPoint:function(coord,q) {
		return this.translate(coord).rotate(q).translate(coord.multiply(-1));
	},
	
	inverse:function() {
		var mult = 1/this.determinant();
		
		return $T(mult * this.m22,
				  mult * -1 * this.m12,
				  mult * -1 * this.m21,
				  mult * this.m11,
				  mult * (this.m12 * this.dy - this.dx * this.m22),
				  mult * (this.dx * this.m21 - this.m11 * this.dy));
	},
	
	determinant:function() {
		return (this.m11 * this.m22) - (this.m21 * this.m12);
	},
	
	globalToLocal:function(coord) {
		
		var inverse = this.inverse();
		
		return $C(inverse.m11 * coord.x + inverse.m12 * coord.y + inverse.dx,
				  inverse.m21 * coord.x + inverse.m22 * coord.y + inverse.dy);
	},
	
	localToGlobal:function(coord) {
		return $C(this.m11 * coord.x + this.m12 * coord.y + this.dx,
				  this.m21 * coord.x + this.m22 * coord.y + this.dy);
	}
});

Object.extend(MishaTools_Canvas_Transform,{
	Identity:function() {
		return $T(1,0,0,1,0,0);
	}
});