MishaTools_LoadScripts.RequireOnce(
['MishaTools/Observable.js'],
function() {
	MishaTools_ClipboardAccess = Class.create(MishaTools_Observable,{
		initialize:function($super) {
			$super();
			
			this.copypaster = new Element('textarea',{id:'_copypaster',style:'position: absolute; z-index: -400; top: -200px; left: -200px;',tabindex:-1});
			document.body.appendChild(this.copypaster);
			
			this.copypaster.observe('paste',function(e) {
				setTimeout(function() {
					this.originalfocus.focus();
					this.fire('paste',{text:this.copypaster.value});
				}.bind(this),0);
			}.bindAsEventListener(this));
			
			this.copypaster.observe('copy',function(e) {
				this.originalfocus.focus();
			}.bindAsEventListener(this));
			
			this.copypaster.observe('cut',function(e) {
				this.originalfocus.focus();
			}.bindAsEventListener(this));
		},
		
		interceptCopy:function(text) {
			this.fire('copy',{text:text});
			
			this.copypaster.value = text;
			this.originalfocus = document.activeElement;
			this.copypaster.select();
		},
		
		interceptCut:function(text) {
			this.fire('cut',{text:text});
			
			this.copypaster.value = text;
			this.originalfocus = document.activeElement;
			this.copypaster.select();
		},
		
		interceptPaste:function(func) {
			var listener = function(e) {
				func(e.data.text);
			};
			
			this.originalfocus = document.activeElement;
			this.copypaster.select();
			this.observe('paste',this.selfDestructListener(listener));
		}
	});
	
	Object.extend(MishaTools_ClipboardAccess,{
		Create:function() {
			if(Object.isUndefined(MishaTools_ClipboardAccess.ClipboardAccess)) MishaTools_ClipboardAccess.ClipboardAccess = new MishaTools_ClipboardAccess;
			return MishaTools_ClipboardAccess.ClipboardAccess;
		}
	});
});