MishaTools_LoadScripts.RequireOnce(
['MishaTools/Observable.js'],
function() {

	$D = function(func,dependencies) {
		return new MishaTools_Dependency(func,dependencies);
	};
	
	MishaTools_Dependency = Class.create(MishaTools_Observable,{
		initialize:function($super,func,dependencies,equalityfunc) {
			$super();
			
			this.value = undefined;
			this.dependencies = [];
			this.dependees = [];
			
			if(!equalityfunc) equalityfunc = function(oldval,newval) { return oldval === newval; };
			
			this.change(func,dependencies,equalityfunc);
		},
		
		evaluate:function() {
			var oldvalue = this.value;
			this.value = this.func.apply(this,this.dependencies.pluck('value'));
			
			this.fire('evaluated',{oldvalue:oldvalue,newvalue:this.value});
			
			if(!this.equalityfunc(oldvalue,this.value)) {
				this.fire('changed',{oldvalue:oldvalue,newvalue:this.value});
				
				//notify the dependees
				this.dependees.invoke('evaluate');
			}
			
			return this.value;
		},
		
		change:function(func,dependencies,equalityfunc) {
		
			if(!Object.isFunction(func)) this.func = function() { return func; };
			else this.func = func;
			
			if(Object.isFunction(equalityfunc)) this.equalityfunc = equalityfunc;
			
			this.setDependencies(dependencies || []);
			return this.evaluate();
		},
		
		clone:function() {
			return $D(this.func,this.dependencies);
		},
			
		setDependencies:function(dependencies) {
			//if any dependencies exist that are dependency objects, tell them we no longer depend on them
			this.dependencies.each(function(dependency) {
				dependency.dependees.reject(function(dependee) { return dependee == this; },this);
				if(dependency.dependees.length == 0) dependecy.fire('inactive');
			},this);
			
			this.dependencies = dependencies;
			
			//if the dependency is a dependency object, tell them we now depend on them
			this.dependencies.each(function(dependency) {
				dependency.dependees.push(this);
				if(dependency.dependees.length == 1) dependency.fire('active');
			},this);
		}
	});
});