MishaTools_Helpers = {
	Assert:function(assertion,message,code) {
		if(window.debug && !assertion) {
			throw new Error(code || 'ASSERT_FAILED', message || 'Assertion failed.');
		}
	},
	
	AssertType:function(obj,type,message,code) {
		if(window.debug && !MishaTools_Base.IsType(obj,type)) {
			throw new Error(code || 'ASSERT_FAILED', message || 'Assertion failed.');
		}
	},
	
	IsType:function(value,type,strict) {
		if(type != Array && MishaTools_Helpers.IsType(type,Array)) return type.any(function(t) { return MishaTools_Helpers.IsType(value,t,strict); });
		else {
			if(type === null || type === undefined) return type === value;
			else return value !== null && value !== undefined && ((!strict && MishaTools_Helpers.IsDerivedFrom(value.constructor,type)) || (strict && value instanceof type));
		}
	},
	
	IsDerivedFrom:function(type,fromtype) {
		if(type == fromtype) {
		 return true;
		} else if(type.superclass) {
		 return IsDerivedFrom(type.superclass,fromtype);
		} else return false;
	},
	
	ExpandToArray:function(a) {
		if(Object.isUndefined(a)) return [];
		else if(!Object.isArray(a)) return [a];
		else return a;
	},
	
	ArrayCompare:function(a,b) {
		if(!Object.isArray(a) || !Object.isArray(b)) return false;
		
		if(a.length != b.length) return false;
		
		for(var i=0;i<a.length;i++) {
			if(a[i] != b[i]) return false;
		}
		return true;
	},
	
	ArrayDiff:function(source,target,ordered) {
		//returns what is in source and not target
		return source.reject(function(sourceelement,i) {
			if(ordered) return sourceelement == target[i];
			else {
				return target.any(function(targetelement) {
					return targetelement == sourceelement;
				});
			}
		});
	},
	
	RemoveStringAtPos:function(string,pos,length) {
		return string.substring(0,pos-length) + string.substring(pos);
	},
	
	InsertStringAtPos:function(string,pos,str) {
		return string.substring(0,pos) + str + string.substring(pos);
	},
	
	IsAlphaNumeric:function(chr) {
		var chrcode = chr.charCodeAt(0);
		return ((chrcode < 48) || (chrcode > 122) || ((chrcode > 57) && (chrcode < 65)) || ((chrcode > 90) && (chrcode < 97))) ? false : true;
	},
	
	RequestAnimFrame:(function(){
		  return  window.requestAnimationFrame       || 
				  window.webkitRequestAnimationFrame || 
				  window.mozRequestAnimationFrame    || 
				  window.oRequestAnimationFrame      || 
				  window.msRequestAnimationFrame     || 
				  function(/* function */ callback, /* DOMElement */ element){
					window.setTimeout(callback, 1000 / 60);
				  };
		})(),
		
	LoadImages:function(srcs,callback) {
		var loadimages = function(images,srcs,callback) {
			var image = new Image();
			image.onload = function() {
				srcs.shift();
				images.push(image);
				
				if(srcs.length > 0) loadimages(images,srcs,callback);
				else callback(images);
			};
			image.src = srcs[0];
		};
		
		loadimages([],srcs,callback);
	},
	
	IsMobileBrowser:function() {
		return ((navigator.userAgent.match(/iPhone/i)) || (navigator.userAgent.match(/iPod/i)) || (navigator.userAgent.match(/iPad/i)));
	}
};

Object.extend(window,MishaTools_Helpers);