MishaTools_LoadScripts.RequireOnce(
['MishaTools/Helpers.js'],
function() {
	MishaTools_Observable = Class.create({
		initialize:function() {
			this.listeners = new Hash();
		},
		
		observe:function(event,callback) {
			if(this.listeners[event] && this.listeners[event].any(function(listener) { return listener == callback })) return;
			
			this.listeners[event] = ExpandToArray(this.listeners[event]).concat([callback]);
		},
		
		stopObserving:function(event,callback) {
			if(callback) {			
				this.listeners[event] = this.listeners[event].reject(function(i) { return i == callback; });
				if(this.listeners[event].length == 0) this.listeners.unset(event);
			} else if(event) {
				this.listeners.unset(event);
			} else {
				this.listeners = new Hash();
			}
		},
		
		fire:function(event,data) {
			if(this.listeners[event]) {
				this.listeners[event].each(function(listener) { listener({event:event,data:data,target:this}); },this);
			}
		},
		
		selfDestructListener:function(func) {
			var wrapper = func.wrap(function(func,e) {
				func(e);
				this.stopObserving(e.event,wrapper);
			}.bind(this));
			return wrapper;
		}
	});
});